/* imap-atom-parameter.c generated by valac 0.54.8, the Vala compiler
 * generated from imap-atom-parameter.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	GEARY_IMAP_ATOM_PARAMETER_0_PROPERTY,
	GEARY_IMAP_ATOM_PARAMETER_NUM_PROPERTIES
};
static GParamSpec* geary_imap_atom_parameter_properties[GEARY_IMAP_ATOM_PARAMETER_NUM_PROPERTIES];

static gpointer geary_imap_atom_parameter_parent_class = NULL;

static void geary_imap_atom_parameter_real_serialize (GearyImapParameter* base,
                                               GearyImapSerializer* ser,
                                               GCancellable* cancellable,
                                               GError** error);
static GType geary_imap_atom_parameter_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GearyImapAtomParameter*
geary_imap_atom_parameter_construct (GType object_type,
                                     const gchar* value)
{
	GearyImapAtomParameter * self = NULL;
	g_return_val_if_fail (value != NULL, NULL);
	self = (GearyImapAtomParameter*) geary_imap_unquoted_string_parameter_construct (object_type, value);
	return self;
}

GearyImapAtomParameter*
geary_imap_atom_parameter_new (const gchar* value)
{
	return geary_imap_atom_parameter_construct (GEARY_IMAP_TYPE_ATOM_PARAMETER, value);
}

/**
     * {@inheritDoc}
     */
static void
geary_imap_atom_parameter_real_serialize (GearyImapParameter* base,
                                          GearyImapSerializer* ser,
                                          GCancellable* cancellable,
                                          GError** error)
{
	GearyImapAtomParameter * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_IMAP_TYPE_ATOM_PARAMETER, GearyImapAtomParameter);
	g_return_if_fail (GEARY_IMAP_IS_SERIALIZER (ser));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
	_tmp0_ = geary_imap_string_parameter_get_ascii (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_IMAP_TYPE_STRING_PARAMETER, GearyImapStringParameter));
	_tmp1_ = _tmp0_;
	geary_imap_serializer_push_unquoted_string (ser, _tmp1_, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}

static void
geary_imap_atom_parameter_class_init (GearyImapAtomParameterClass * klass,
                                      gpointer klass_data)
{
	geary_imap_atom_parameter_parent_class = g_type_class_peek_parent (klass);
	((GearyImapParameterClass *) klass)->serialize = (void (*) (GearyImapParameter*, GearyImapSerializer*, GCancellable*, GError**)) geary_imap_atom_parameter_real_serialize;
}

static void
geary_imap_atom_parameter_instance_init (GearyImapAtomParameter * self,
                                         gpointer klass)
{
}

/**
 * A representation of an IMAP atom.
 *
 * This class does not check if quoting is required.  Use {@link DataFormat.is_quoting_required}
 * or {@link StringParameter.get_best_for}.
 *
 * See {@link StringParameter} for a note about class hierarchy.  In particular, note that
 * [@link Deserializer} will not create this type of {@link Parameter} because it's unable to
 * deduce if a string is an atom or a string from syntax alone.
 *
 * See [[http://tools.ietf.org/html/rfc3501#section-4.1]]
 */
 G_GNUC_NO_INLINE static GType
geary_imap_atom_parameter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapAtomParameterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_atom_parameter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapAtomParameter), 0, (GInstanceInitFunc) geary_imap_atom_parameter_instance_init, NULL };
	GType geary_imap_atom_parameter_type_id;
	geary_imap_atom_parameter_type_id = g_type_register_static (GEARY_IMAP_TYPE_UNQUOTED_STRING_PARAMETER, "GearyImapAtomParameter", &g_define_type_info, 0);
	return geary_imap_atom_parameter_type_id;
}

GType
geary_imap_atom_parameter_get_type (void)
{
	static volatile gsize geary_imap_atom_parameter_type_id__volatile = 0;
	if (g_once_init_enter (&geary_imap_atom_parameter_type_id__volatile)) {
		GType geary_imap_atom_parameter_type_id;
		geary_imap_atom_parameter_type_id = geary_imap_atom_parameter_get_type_once ();
		g_once_init_leave (&geary_imap_atom_parameter_type_id__volatile, geary_imap_atom_parameter_type_id);
	}
	return geary_imap_atom_parameter_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

